<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">О заказах от каких клиентов вас уведомлять</p>
      </div>
    </div>

    <div class="row">
      <div class="col-xs-12">
        <ob-radio
          v-for="item in customers"
          :key="item.value"
          :label="item.title"
          v-model="_isAll"
          :valueInput="item.value"
          :disabled="item.disabled"
        />
      </div>
    </div>
    <div
      v-if="!isAll"
      class="row"
    >
      <div class="col-xs-12">
        <ObSelect
          label="Клиенты"
          placeholder="Выберите одного или несколько клиентов"
          required
          :value="clientUuids"
          :remote-opt="{
            method: showListClients,
          }"
          :pageLimit="500"
          :is-dropdown="true"
          :isAutoComplete="true"
          data-qa="selectedCustomer"
          display-exp="title"
          @input="input($event)"
        />
      </div>
    </div>
  </div>
</template>

<script>
  import ObRadio from 'common-components/src/obComponents/obRadio';
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import api from '@/api'
  import { mapGetters } from 'vuex';
  export default {
    name: 'SubscriptionModalClients',
    components: {
      ObRadio,
      ObSelect
    },
    data () {
      return {};
    },
    props: {
      clientUuids: {
        type: Array,
      },
      isAll: {
        type: Boolean
      }
    },
    computed: {
      ...mapGetters({
        listClients: 'subscriptions/listClients',
        role: 'user/role'
      }),
      customers () {
        return [
          {
            title: 'От всех',
            value: true,
            disabled: false
          },
          {
            title: 'Выбрать индивидуально',
            value: false,
            disabled: this.role === 'client'
          }
        ]
      },
      _isAll: {
        get() {
          return this.isAll
        },
        set(data) {
          this.$emit('setClients', { isAll: data, clientsUuids: [] })
        }
      }
    },
    methods: {
      input (clientUuids) {
        this.$emit('setClients', { clientUuids, isAll: false })
      },
      showListClients({ sort, direction, page, size, query }) {
        const q = query || 'CLIENT';

        try {
          return api.subscriptions.showListClients(sort, direction, page, size, q)
        } catch (e) {
          console.error(e);
        }
      }
    }
  };
</script>